function vexalarm.options.spells.settings.panel()
	local printableClassnames = {"DeathKnight", "Druid", "Hunter", "Mage", "Monk", "Paladin", "Priest", "Rogue", "Shaman", "Warlock", "Warrior", "no class"}
	local classnames = {"DEATHKNIGHT", "DRUID", "HUNTER", "MAGE", "MONK", "PALADIN", "PRIEST", "ROGUE", "SHAMAN", "WARLOCK", "WARRIOR", ""}
	local rolenames = {"all", "tank", "heal", "dd", "no role"}
	local orderStartvalue = 100
	local enable = {
		{"+", "enable", true},
		{"-", "disable", false}}
	local definitiontexts = {
		"Buffs that have a single target",
		"Buffs that have no target and are mostly casted on yourself",
		"Buffs that effect multiple targets",
		"Casts that have a target",
		"Casts that have no target and are mostly casted on yourself"}
	local rank = 0
	local spelltypes = {"buffWtarget", "buffWOtarget", "grpbuff", "castWtarget", "castWOtarget"}
	
	local options = {
		type = "group",
		args = {
			eventtypegrp = {
				name = "Filter",
				type="group", order= 2, dialogInline = true,
				args = {
					classes = {
						name = "Class",
						order = 1, type ="select", width="half",
						values = {
							[1] = "General",
							[2] = "|CFF"..vexalarm.colorize.getHexClassColor("DEATHKNIGHT").."DK|r",
							[3] = "|CFF"..vexalarm.colorize.getHexClassColor("DRUID").."Druid|r",
							[4] = "|CFF"..vexalarm.colorize.getHexClassColor("HUNTER").."Hunter|r",
							[5] = "|CFF"..vexalarm.colorize.getHexClassColor("MAGE").."Mage|r",
							[6] = "|CFF"..vexalarm.colorize.getHexClassColor("MONK").."Monk|r",
							[7] = "|CFF"..vexalarm.colorize.getHexClassColor("PALADIN").."Paladin|r",
							[8] = "|CFF"..vexalarm.colorize.getHexClassColor("PRIEST").."Priest|r",
							[9] = "|CFF"..vexalarm.colorize.getHexClassColor("ROGUE").."Rogue|r",
							[10] = "|CFF"..vexalarm.colorize.getHexClassColor("SHAMAN").."Shaman|r",
							[11] = "|CFF"..vexalarm.colorize.getHexClassColor("WARLOCK").."Warlock|r",
							[12] = "|CFF"..vexalarm.colorize.getHexClassColor("WARRIOR").."Warrior|r"},
						set = function(info,key) vexalarm.options.spells.settings.setClassFilter(key) vexalarm.initialize.core(true) end,
						get = function() return vexalarm.options.spells.settings.getClassFilter() end,
						},
					name = {
						name = "Name",
						order=3, type = "input", multiline = false, width="half",
						set = function(info,val) vexalarm.options.spells.settings.name = val vexalarm.initialize.core(true) end,
						get = function() return vexalarm.options.spells.settings.name end
						},
					spells = {
						name = "Spells to adjust:",
						order =11, type ="select", width="double",
						values = vexalarm.options.spells.profiles.getList(true,true),
						set = function(info,key) vexalarm.options.spells.settings.SP=key vexalarm.options.spells.profiles.name=key vexalarm.initialize.core(true) end,
						get = function() return vexalarm.options.spells.settings.SP end,
						},	
					}
				}
			}
		}
	
	local optiongrp = {
		name = "Toggle Settings", type = "group", dialogInline = true, args = {}, order=10,
		}
		
	
	-- +/- buttons
	local role = 0
	for i=1,5 do
		for j=1,2 do
			if i == 1 then 	role = nil		rank = (j*15)+1
			else 			role = i-1 		rank = i+(10*j) end
			optiongrp.args[tostring(vexalarm_optionTab_Spells_eventType).."_"..enable[j][2].."_role_"..tostring(i)] = vexalarm.options.spells.settings.createButton(rolenames[i], enable[j], role, rank)
		end
	end
	
	options.args["buttons"] = optiongrp
	
	
	--SPELLS
	local spellrank = 0
	local spelllist = vexalarm.options.spells.settings.getListSorted(classnames[vexalarm.options.spells.settings.class])
	local spells = { name = printableClassnames[vexalarm.options.spells.settings.class], type = "group", dialogInline = true, args = {}, order=orderStartvalue}
	for j in ipairs(spelllist) do
		local key = spelllist[j][2]
		spellrank = spellrank + 1
		rank = (spellrank*10)+orderStartvalue
		
		
		spells.args[tostring(rank)] = vexalarm.options.spells.settings.createDesc(key, rank)
		spells.args[tostring(rank+1)] = vexalarm.options.spells.settings.createToolTipButton(key, rank+1, printableClassnames[vexalarm.options.spells.settings.class], classnames[vexalarm.options.spells.settings.class])
		for z=1,4 do
			spells.args[tostring(rank+z+2)] = vexalarm.options.spells.settings.createToggle(rolenames[z+1], key, z, rank+z+2)
		end
		spells.args[tostring(rank+7)] = vexalarm.options.spells.settings.createToggleTarget(key,rank+7)
		spells.args[tostring(rank+8)] = vexalarm.options.spells.settings.createToggleTrackBuff(key,rank+8)
		if j ~= #spelllist then spells.args[tostring(rank+9)] = {name = "\n", type="description", order=rank+9} end	
		
		
	end
	options.args["spells"..vexalarm.options.spells.settings.class] = spells

	return options
end
